osg::Texture Class Referenceabstract

`#include <Texture>`

Inheritance diagram for osg::Texture:

## Classes

struct | TextureProfile
class | TextureObject

## Public Types

enum | WrapParameter { WRAP_S , WRAP_T , WRAP_R }
enum | WrapMode { CLAMP = GL_CLAMP , CLAMP_TO_EDGE = GL_CLAMP_TO_EDGE , CLAMP_TO_BORDER = GL_CLAMP_TO_BORDER_ARB , REPEAT = GL_REPEAT , MIRROR = GL_MIRRORED_REPEAT_IBM }
enum | FilterParameter { MIN_FILTER , MAG_FILTER }
enum | FilterMode { LINEAR = GL_LINEAR , LINEAR_MIPMAP_LINEAR = GL_LINEAR_MIPMAP_LINEAR , LINEAR_MIPMAP_NEAREST = GL_LINEAR_MIPMAP_NEAREST , NEAREST = GL_NEAREST , NEAREST_MIPMAP_LINEAR = GL_NEAREST_MIPMAP_LINEAR , NEAREST_MIPMAP_NEAREST = GL_NEAREST_MIPMAP_NEAREST }
enum | InternalFormatMode { USE_IMAGE_DATA_FORMAT , USE_USER_DEFINED_FORMAT , USE_ARB_COMPRESSION , USE_S3TC_DXT1_COMPRESSION , USE_S3TC_DXT3_COMPRESSION , USE_S3TC_DXT5_COMPRESSION , USE_PVRTC_2BPP_COMPRESSION , USE_PVRTC_4BPP_COMPRESSION , USE_ETC_COMPRESSION , USE_ETC2_COMPRESSION , USE_RGTC1_COMPRESSION , USE_RGTC2_COMPRESSION , USE_S3TC_DXT1c_COMPRESSION , USE_S3TC_DXT1a_COMPRESSION }
enum | InternalFormatType { NORMALIZED = 0x0 , FLOAT = 0x1 , SIGNED_INTEGER = 0x2 , UNSIGNED_INTEGER = 0x4 }
enum | ShadowCompareFunc { NEVER = GL_NEVER , LESS = GL_LESS , EQUAL = GL_EQUAL , LEQUAL = GL_LEQUAL , GREATER = GL_GREATER , NOTEQUAL = GL_NOTEQUAL , GEQUAL = GL_GEQUAL , ALWAYS = GL_ALWAYS }
enum | ShadowTextureMode { LUMINANCE = GL_LUMINANCE , INTENSITY = GL_INTENSITY , ALPHA = GL_ALPHA , NONE = GL_NONE }
enum | GenerateMipmapMode { GENERATE_MIPMAP_NONE , GENERATE_MIPMAP , GENERATE_MIPMAP_TEX_PARAMETER }
typedef std::list< ref_ptr< TextureObject > > | TextureObjectList
Public Types inherited from osg::StateAttribute
enum | Values { OFF = 0x0 , ON = 0x1 , OVERRIDE = 0x2 , PROTECTED = 0x4 , INHERIT = 0x8 }

enum

Type {
TEXTURE , POLYGONMODE , POLYGONOFFSET , MATERIAL ,
ALPHAFUNC , ANTIALIAS , COLORTABLE , CULLFACE ,
FOG , FRONTFACE , LIGHT , POINT ,
LINEWIDTH , LINESTIPPLE , POLYGONSTIPPLE , SHADEMODEL ,
TEXENV , TEXENVFILTER , TEXGEN , TEXMAT ,
LIGHTMODEL , BLENDFUNC , BLENDEQUATION , LOGICOP ,
STENCIL , COLORMASK , DEPTH , VIEWPORT ,
SCISSOR , BLENDCOLOR , MULTISAMPLE , CLIPPLANE ,
COLORMATRIX , VERTEXPROGRAM , FRAGMENTPROGRAM , POINTSPRITE ,
PROGRAM , CLAMPCOLOR , HINT , SAMPLEMASKI ,
PRIMITIVERESTARTINDEX , CLIPCONTROL , VALIDATOR , VIEWMATRIXEXTRACTOR ,
OSGNV_PARAMETER_BLOCK , OSGNVEXT_TEXTURE_SHADER , OSGNVEXT_VERTEX_PROGRAM , OSGNVEXT_REGISTER_COMBINERS ,
OSGNVCG_PROGRAM , OSGNVSLANG_PROGRAM , OSGNVPARSE_PROGRAM_PARSER , UNIFORMBUFFERBINDING ,
TRANSFORMFEEDBACKBUFFERBINDING , ATOMICCOUNTERBUFFERBINDING , PATCH_PARAMETER , FRAME_BUFFER_OBJECT ,
VERTEX_ATTRIB_DIVISOR , SHADERSTORAGEBUFFERBINDING , INDIRECTDRAWBUFFERBINDING , VIEWPORTINDEXED ,
DEPTHRANGEINDEXED , SCISSORINDEXED , BINDIMAGETEXTURE , SAMPLER ,
CAPABILITY = 100
}

typedef GLenum | GLMode
typedef unsigned int | GLModeValue
typedef unsigned int | OverrideValue
typedef std::pair< Type, unsigned int > | TypeMemberPair
typedef std::vector< StateSet * > | ParentList
typedef osg::StateAttributeCallback | Callback
Public Types inherited from osg::Object
enum | DataVariance { DYNAMIC , STATIC , UNSPECIFIED }

## Public Member Functions

| Texture ()
| Texture (const Texture &text, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
virtual osg::Object * | cloneType () const =0
virtual osg::Object * | clone (const CopyOp &copyop) const =0
virtual bool | isSameKindAs (const osg::Object *obj) const
virtual const char * | libraryName () const
virtual const char * | className () const
virtual Texture * | asTexture ()
virtual const Texture * | asTexture () const
virtual Type | getType () const
virtual bool | isTextureAttribute () const
virtual GLenum | getTextureTarget () const =0
virtual int | getTextureWidth () const
virtual int | getTextureHeight () const
virtual int | getTextureDepth () const
void | setWrap (WrapParameter which, WrapMode wrap)
WrapMode | getWrap (WrapParameter which) const
void | setBorderColor (const Vec4d &color)
const Vec4d & | getBorderColor () const
void | setBorderWidth (GLint width)
GLint | getBorderWidth () const
void | setFilter (FilterParameter which, FilterMode filter)
FilterMode | getFilter (FilterParameter which) const
void | setMaxAnisotropy (float anis)
float | getMaxAnisotropy () const
void | setMinLOD (float minlod)
float | getMinLOD () const
void | setMaxLOD (float maxlod)
float | getMaxLOD () const
void | setLODBias (float lodbias)
float | getLODBias () const
void | setSwizzle (const Vec4i &swizzle)
const Vec4i & | getSwizzle () const
void | setUseHardwareMipMapGeneration (bool useHardwareMipMapGeneration)
bool | getUseHardwareMipMapGeneration () const
void | setUnRefImageDataAfterApply (bool flag)
bool | getUnRefImageDataAfterApply () const
void | setClientStorageHint (bool flag)
bool | getClientStorageHint () const
void | setResizeNonPowerOfTwoHint (bool flag)
bool | getResizeNonPowerOfTwoHint () const
void | setInternalFormatMode (InternalFormatMode mode)
InternalFormatMode | getInternalFormatMode () const
void | setInternalFormat (GLint internalFormat)
GLint | getInternalFormat () const
bool | isCompressedInternalFormat () const
void | setSourceFormat (GLenum sourceFormat)
GLenum | getSourceFormat () const
void | setSourceType (GLenum sourceType)
GLenum | getSourceType () const
InternalFormatType | getInternalFormatType () const
GLenum | selectSizedInternalFormat (const osg::Image *image=0) const
virtual bool | isDirty (unsigned int) const
TextureObject * | getTextureObject (unsigned int contextID) const
void | setTextureObject (unsigned int contextID, TextureObject *to)
void | dirtyTextureObject ()
bool | areAllTextureObjectsLoaded () const
unsigned int & | getTextureParameterDirty (unsigned int contextID) const
void | dirtyTextureParameters ()
void | allocateMipmapLevels ()
void | setShadowComparison (bool flag)
bool | getShadowComparison () const
void | setShadowCompareFunc (ShadowCompareFunc func)
ShadowCompareFunc | getShadowCompareFunc () const
void | setShadowTextureMode (ShadowTextureMode mode)
ShadowTextureMode | getShadowTextureMode () const
void | setShadowAmbient (float shadow_ambient)
float | getShadowAmbient () const
virtual void | setImage (unsigned int face, Image *image)=0
template<class T>
void | setImage (unsigned int face, const ref_ptr< T > &image)
virtual Image * | getImage (unsigned int face)=0
virtual const Image * | getImage (unsigned int face) const =0
virtual unsigned int | getNumImages () const =0
void | setReadPBuffer (GraphicsContext *context)
template<class T>
void | setReadPBuffer (const ref_ptr< T > &context)
GraphicsContext * | getReadPBuffer ()
const GraphicsContext * | getReadPBuffer () const
virtual void | apply (State &state) const =0
virtual void | compileGLObjects (State &state) const
virtual void | resizeGLObjectBuffers (unsigned int maxSize)
virtual void | releaseGLObjects (State *state=0) const
void | applyTexImage2D_load (State &state, GLenum target, const Image *image, GLsizei width, GLsizei height, GLsizei numMipmapLevels) const
void | applyTexImage2D_subload (State &state, GLenum target, const Image *image, GLsizei width, GLsizei height, GLint inInternalFormat, GLsizei numMipmapLevels) const
TextureObject * | generateAndAssignTextureObject (unsigned int contextID, GLenum target) const
TextureObject * | generateAndAssignTextureObject (unsigned int contextID, GLenum target, GLint numMipmapLevels, GLenum internalFormat, GLsizei width, GLsizei height, GLsizei depth, GLint border) const
Public Member Functions inherited from osg::StateAttribute
| StateAttribute ()
| StateAttribute (const StateAttribute &sa, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
virtual StateAttribute * | asStateAttribute ()
virtual const StateAttribute * | asStateAttribute () const
virtual unsigned int | getMember () const
TypeMemberPair | getTypeMemberPair () const
virtual int | compare (const StateAttribute &sa) const =0
bool | operator< (const StateAttribute &rhs) const
bool | operator== (const StateAttribute &rhs) const
bool | operator!= (const StateAttribute &rhs) const
const ParentList & | getParents () const
StateSet * | getParent (unsigned int i)
const StateSet * | getParent (unsigned int i) const
unsigned int | getNumParents () const
void | setShaderComponent (ShaderComponent *sc)
ShaderComponent * | getShaderComponent ()
const ShaderComponent * | getShaderComponent () const
virtual bool | getModeUsage (ModeUsage &) const
virtual bool | checkValidityOfAssociatedModes (osg::State &) const
void | setUpdateCallback (StateAttributeCallback *uc)
StateAttributeCallback * | getUpdateCallback ()
const StateAttributeCallback * | getUpdateCallback () const
void | setEventCallback (StateAttributeCallback *ec)
StateAttributeCallback * | getEventCallback ()
const StateAttributeCallback * | getEventCallback () const
Public Member Functions inherited from osg::Object
| Object ()
| Object (bool threadSafeRefUnref)
| Object (const Object &, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
std::string | getCompoundClassName () const
virtual Node * | asNode ()
virtual const Node * | asNode () const
virtual NodeVisitor * | asNodeVisitor ()
virtual const NodeVisitor * | asNodeVisitor () const
virtual StateSet * | asStateSet ()
virtual const StateSet * | asStateSet () const
virtual Uniform * | asUniform ()
virtual const Uniform * | asUniform () const
virtual Camera * | asCamera ()
virtual const Camera * | asCamera () const
virtual Drawable * | asDrawable ()
virtual const Drawable * | asDrawable () const
virtual Callback * | asCallback ()
virtual const Callback * | asCallback () const
virtual CallbackObject * | asCallbackObject ()
virtual const CallbackObject * | asCallbackObject () const
virtual UserDataContainer * | asUserDataContainer ()
virtual const UserDataContainer * | asUserDataContainer () const
virtual ValueObject * | asValueObject ()
virtual const ValueObject * | asValueObject () const
virtual Image * | asImage ()
virtual const Image * | asImage () const
virtual void | setThreadSafeRefUnref (bool threadSafe)
virtual void | setName (const std::string &name)
void | setName (const char *name)
const std::string & | getName () const
void | setDataVariance (DataVariance dv)
DataVariance | getDataVariance () const
virtual void | computeDataVariance ()
void | setUserDataContainer (osg::UserDataContainer *udc)
template<class T>
void | setUserDataContainer (const ref_ptr< T > &udc)
osg::UserDataContainer * | getUserDataContainer ()
const osg::UserDataContainer * | getUserDataContainer () const
osg::UserDataContainer * | getOrCreateUserDataContainer ()
virtual void | setUserData (Referenced *obj)
template<class T>
void | setUserData (const ref_ptr< T > &ud)
virtual Referenced * | getUserData ()
virtual const Referenced * | getUserData () const
template<typename T>
bool | getUserValue (const std::string &name, T &value) const
template<typename T>
void | setUserValue (const std::string &name, const T &value)
template<typename T>
BoolValueObject UCharValueObject UShortValueObject UIntValueObject DoubleValueObject Vec3fValueObject Vec2dValueObject Vec4dValueObject PlaneValueObject MatrixdValueObject BoundingBoxdValueObject BoundingSpheredValueObject bool | getUserValue (const std::string &name, T &value) const
Public Member Functions inherited from osg::Referenced
| Referenced ()
| Referenced (bool threadSafeRefUnref)
| Referenced (const Referenced &)
Referenced & | operator= (const Referenced &)
bool | getThreadSafeRefUnref () const
OpenThreads::Mutex * | getRefMutex () const
int | ref () const
int | unref () const
int | unref_nodelete () const
int | referenceCount () const
ObserverSet * | getObserverSet () const
ObserverSet * | getOrCreateObserverSet () const
void | addObserver (Observer *observer) const
void | removeObserver (Observer *observer) const

## Static Public Member Functions

static bool | isCompressedInternalFormat (GLint internalFormat)
static void | getCompressedSize (GLenum internalFormat, GLint width, GLint height, GLint depth, GLint &blockSize, GLint &size)
static osg::ref_ptr< TextureObject > | generateTextureObject (const Texture *texture, unsigned int contextID, GLenum target)
static osg::ref_ptr< TextureObject > | generateTextureObject (const Texture *texture, unsigned int contextID, GLenum target, GLint numMipmapLevels, GLenum internalFormat, GLsizei width, GLsizei height, GLsizei depth, GLint border)
Static Public Member Functions inherited from osg::Referenced
static OpenThreads::Mutex * | getGlobalReferencedMutex ()
static void | setDeleteHandler (DeleteHandler *handler)
static DeleteHandler * | getDeleteHandler ()

## Protected Types

typedef buffered_value< unsigned int > | TexParameterDirtyList
typedef buffered_object< ref_ptr< TextureObject > > | TextureObjectBuffer

## Protected Member Functions

virtual | ~Texture ()
virtual void | computeInternalFormat () const =0
void | computeInternalFormatWithImage (const osg::Image &image) const
void | computeRequiredTextureDimensions (State &state, const osg::Image &image, GLsizei &width, GLsizei &height, GLsizei &numMipmapLevels) const
void | computeInternalFormatType () const
void | applyTexParameters (GLenum target, State &state) const
bool | isHardwareMipmapGenerationEnabled (const State &state) const
bool | isSafeToUnrefImageData (const State &state) const
GenerateMipmapMode | mipmapBeforeTexImage (const State &state, bool hardwareMipmapOn) const
void | mipmapAfterTexImage (State &state, GenerateMipmapMode beforeResult) const
void | generateMipmap (State &state) const
virtual void | allocateMipmap (State &state) const =0
int | compareTexture (const Texture &rhs) const
int | compareTextureObjects (const Texture &rhs) const
Protected Member Functions inherited from osg::StateAttribute
virtual | ~StateAttribute ()
void | addParent (osg::StateSet *object)
void | removeParent (osg::StateSet *object)
Protected Member Functions inherited from osg::Object
virtual | ~Object ()
Protected Member Functions inherited from osg::Referenced
virtual | ~Referenced ()
void | signalObserversAndDelete (bool signalDelete, bool doDelete) const
void | deleteUsingDeleteHandler () const

## Protected Attributes

TexParameterDirtyList | _texParametersDirtyList
TexParameterDirtyList | _texMipmapGenerationDirtyList
WrapMode | _wrap_s
WrapMode | _wrap_t
WrapMode | _wrap_r
FilterMode | _min_filter
FilterMode | _mag_filter
float | _maxAnisotropy
float | _minlod
float | _maxlod
float | _lodbias
Vec4i | _swizzle
bool | _useHardwareMipMapGeneration
bool | _unrefImageDataAfterApply
bool | _clientStorageHint
bool | _resizeNonPowerOfTwoHint
Vec4d | _borderColor
GLint | _borderWidth
InternalFormatMode | _internalFormatMode
InternalFormatType | _internalFormatType
GLint | _internalFormat
GLenum | _sourceFormat
GLenum | _sourceType
bool | _use_shadow_comparison
ShadowCompareFunc | _shadow_compare_func
ShadowTextureMode | _shadow_texture_mode
float | _shadow_ambient
TextureObjectBuffer | _textureObjectBuffer
ref_ptr< GraphicsContext > | _readPBuffer
Protected Attributes inherited from osg::StateAttribute
ParentList | _parents
ref_ptr< ShaderComponent > | _shaderComponent
ref_ptr< StateAttributeCallback > | _updateCallback
ref_ptr< StateAttributeCallback > | _eventCallback
Protected Attributes inherited from osg::Object
std::string | _name
DataVariance | _dataVariance
osg::UserDataContainer * | _userDataContainer
Protected Attributes inherited from osg::Referenced
OpenThreads::AtomicPtr | _observerSet
OpenThreads::Atomic | _refCount

## Detailed Description

Texture pure virtual base class that encapsulates OpenGL texture functionality common to the various types of OSG textures.

## Member Typedef Documentation

## TexParameterDirtyList

typedef buffered_value<unsigned int> osg::Texture::TexParameterDirtyList

protected

## TextureObjectBuffer

typedef buffered_object< ref_ptr<TextureObject> > osg::Texture::TextureObjectBuffer

protected

## TextureObjectList

typedef std::list< ref_ptr<TextureObject> > osg::Texture::TextureObjectList

## Member Enumeration Documentation

## FilterMode

enum osg::Texture::FilterMode

Enumerator
LINEAR |
LINEAR_MIPMAP_LINEAR |
LINEAR_MIPMAP_NEAREST |
NEAREST |
NEAREST_MIPMAP_LINEAR |
NEAREST_MIPMAP_NEAREST |

## FilterParameter

enum osg::Texture::FilterParameter

Enumerator
MIN_FILTER |
MAG_FILTER |

## GenerateMipmapMode

enum osg::Texture::GenerateMipmapMode

Returned by mipmapBeforeTexImage() to indicate what mipmapAfterTexImage() should do

Enumerator
GENERATE_MIPMAP_NONE |
GENERATE_MIPMAP |
GENERATE_MIPMAP_TEX_PARAMETER |

## InternalFormatMode

enum osg::Texture::InternalFormatMode

Enumerator
USE_IMAGE_DATA_FORMAT |
USE_USER_DEFINED_FORMAT |
USE_ARB_COMPRESSION |
USE_S3TC_DXT1_COMPRESSION |
USE_S3TC_DXT3_COMPRESSION |
USE_S3TC_DXT5_COMPRESSION |
USE_PVRTC_2BPP_COMPRESSION |
USE_PVRTC_4BPP_COMPRESSION |
USE_ETC_COMPRESSION |
USE_ETC2_COMPRESSION |
USE_RGTC1_COMPRESSION |
USE_RGTC2_COMPRESSION |
USE_S3TC_DXT1c_COMPRESSION |
USE_S3TC_DXT1a_COMPRESSION |

## InternalFormatType

enum osg::Texture::InternalFormatType

Texture type determined by the internal texture format

Enumerator
NORMALIZED | default OpenGL format (clamped values to [0,1) or [0,255])
FLOAT | float values, Shader Model 3.0 (see ARB_texture_float)
SIGNED_INTEGER | Signed integer values (see EXT_texture_integer).
UNSIGNED_INTEGER | Unsigned integer value (see EXT_texture_integer).

## ShadowCompareFunc

enum osg::Texture::ShadowCompareFunc

Enumerator
NEVER |
LESS |
EQUAL |
LEQUAL |
GREATER |
NOTEQUAL |
GEQUAL |
ALWAYS |

## ShadowTextureMode

enum osg::Texture::ShadowTextureMode

Enumerator
LUMINANCE |
INTENSITY |
ALPHA |
NONE |

## WrapMode

enum osg::Texture::WrapMode

Enumerator
CLAMP |
CLAMP_TO_EDGE |
CLAMP_TO_BORDER |
REPEAT |
MIRROR |

## WrapParameter

enum osg::Texture::WrapParameter

Enumerator
WRAP_S |
WRAP_T |
WRAP_R |

## Constructor & Destructor Documentation

## Texture() [1/2]

osg::Texture::Texture | ( |  | ) |

Referenced by asTexture(), asTexture(), compareTexture(), compareTextureObjects(), generateTextureObject(), generateTextureObject(), osg::Texture::TextureObject::getTexture(), isSameKindAs(), osg::Texture::TextureObject::setTexture(), Texture(), osg::Texture::TextureObject::TextureObject(), osg::Texture::TextureObject::TextureObject(), and osg::Texture::TextureObject::TextureObject().

## Texture() [2/2]

osg::Texture::Texture | ( | const Texture & | text,
|  | const CopyOp & | copyop = CopyOp::SHALLOW_COPY )

Copy constructor using CopyOp to manage deep vs shallow copy.

References osg::CopyOp::SHALLOW_COPY, and Texture().

## ~Texture()

virtual osg::Texture::~Texture | ( |  | ) |

protected virtual

## Member Function Documentation

## allocateMipmap()

virtual void osg::Texture::allocateMipmap | ( | State & | state | ) | const

protected pure virtual

Allocate mipmap levels of the texture by subsequent calling of glTexImage* function.

Implemented in osg::Texture1D, osg::Texture2D, osg::Texture2DArray, osg::Texture2DMultisample, osg::Texture3D, osg::TextureBuffer, osg::TextureCubeMap, and osg::TextureRectangle.

## allocateMipmapLevels()

void osg::Texture::allocateMipmapLevels | ( |  | ) |

Force a manual allocation of the mipmap levels on the next apply() call. User is responsible for filling the mipmap levels with valid data. The OpenGL's glGenerateMipmapEXT function is used to generate the mipmap levels. If glGenerateMipmapEXT is not supported or texture's internal format is not supported by the glGenerateMipmapEXT, then empty mipmap levels will be allocated manually. The mipmap levels are also allocated if a non-mipmapped min filter is used.

## apply()

virtual void osg::Texture::apply | ( | State & | state | ) | const

pure virtual

Texture is a pure virtual base class, apply must be overridden.

Reimplemented from osg::StateAttribute.

Implemented in osg::Texture1D, osg::Texture2D, osg::Texture2DArray, osg::Texture2DMultisample, osg::Texture3D, osg::TextureBuffer, osg::TextureCubeMap, and osg::TextureRectangle.

## applyTexImage2D_load()

void osg::Texture::applyTexImage2D_load | ( | State & | state,
|  | GLenum | target,
|  | const Image * | image,
|  | GLsizei | width,
|  | GLsizei | height,
|  | GLsizei | numMipmapLevels ) const

Helper method. Creates the texture, but doesn't set or use a texture binding. Note: Don't call this method directly unless you're implementing a subload callback.

## applyTexImage2D_subload()

void osg::Texture::applyTexImage2D_subload | ( | State & | state,
|  | GLenum | target,
|  | const Image * | image,
|  | GLsizei | width,
|  | GLsizei | height,
|  | GLint | inInternalFormat,
|  | GLsizei | numMipmapLevels ) const

Helper method. Subloads images into the texture, but doesn't set or use a texture binding. Note: Don't call this method directly unless you're implementing a subload callback.

## applyTexParameters()

void osg::Texture::applyTexParameters | ( | GLenum | target,
|  | State & | state ) const

protected

Helper method. Sets texture parameters.

## areAllTextureObjectsLoaded()

bool osg::Texture::areAllTextureObjectsLoaded | ( |  | ) | const

Returns true if the texture objects for all the required graphics contexts are loaded.

Referenced by isSafeToUnrefImageData().

## asTexture() [1/2]

virtual Texture * osg::Texture::asTexture | ( |  | ) |

inline virtual

Fast alternative to dynamic_cast<> for determining if state attribute is a Texture.

Reimplemented from osg::StateAttribute.

References Texture().

## asTexture() [2/2]

virtual const Texture * osg::Texture::asTexture | ( |  | ) | const

inline virtual

Fast alternative to dynamic_cast<> for determining if state attribute is a Texture.

Reimplemented from osg::StateAttribute.

References Texture().

## className()

virtual const char * osg::Texture::className | ( |  | ) | const

inline virtual

Return the name of the attribute's class type.

Reimplemented from osg::StateAttribute.

Reimplemented in osgText::GlyphTexture.

## clone()

virtual osg::Object * osg::Texture::clone | ( | const CopyOp & |  | ) | const

pure virtual

Clone an attribute, with Object* return type. Must be defined by derived classes.

Implements osg::StateAttribute.

## cloneType()

virtual osg::Object * osg::Texture::cloneType | ( |  | ) | const

pure virtual

Clone the type of an attribute, with Object* return type. Must be defined by derived classes.

Implements osg::StateAttribute.

## compareTexture()

int osg::Texture::compareTexture | ( | const Texture & | rhs | ) | const

protected

Returns -1 if *this < *rhs, 0 if *this==*rhs, 1 if *this>*rhs.

References Texture().

## compareTextureObjects()

int osg::Texture::compareTextureObjects | ( | const Texture & | rhs | ) | const

protected

Returns -1 if *this < *rhs, 0 if *this==*rhs, 1 if *this>*rhs.

References Texture().

## compileGLObjects()

virtual void osg::Texture::compileGLObjects | ( | State & | state | ) | const

virtual

Calls apply(state) to compile the texture.

Reimplemented from osg::StateAttribute.

## computeInternalFormat()

virtual void osg::Texture::computeInternalFormat | ( |  | ) | const

protected pure virtual

Implemented in osg::Texture1D, osg::Texture2D, osg::Texture2DArray, osg::Texture2DMultisample, osg::Texture3D, osg::TextureBuffer, osg::TextureCubeMap, and osg::TextureRectangle.

Referenced by getInternalFormat().

## computeInternalFormatType()

void osg::Texture::computeInternalFormatType | ( |  | ) | const

protected

Computes the internal format type.

Referenced by setInternalFormat().

## computeInternalFormatWithImage()

void osg::Texture::computeInternalFormatWithImage | ( | const osg::Image & | image | ) | const

protected

Computes the internal format from Image parameters.

## computeRequiredTextureDimensions()

void osg::Texture::computeRequiredTextureDimensions | ( | State & | state,
|  | const osg::Image & | image,
|  | GLsizei & | width,
|  | GLsizei & | height,
|  | GLsizei & | numMipmapLevels ) const

protected

Computes the texture dimension for the given Image.

## dirtyTextureObject()

void osg::Texture::dirtyTextureObject | ( |  | ) |

Forces a recompile on next apply() of associated OpenGL texture objects.

## dirtyTextureParameters()

void osg::Texture::dirtyTextureParameters | ( |  | ) |

Force a reset on next apply() of associated OpenGL texture parameters.

Referenced by setBorderColor(), setBorderWidth(), and setSwizzle().

## generateAndAssignTextureObject() [1/2]

TextureObject * osg::Texture::generateAndAssignTextureObject | ( | unsigned int | contextID,
|  | GLenum | target ) const

## generateAndAssignTextureObject() [2/2]

TextureObject * osg::Texture::generateAndAssignTextureObject | ( | unsigned int | contextID,
|  | GLenum | target,
|  | GLint | numMipmapLevels,
|  | GLenum | internalFormat,
|  | GLsizei | width,
|  | GLsizei | height,
|  | GLsizei | depth,
|  | GLint | border ) const

## generateMipmap()

void osg::Texture::generateMipmap | ( | State & | state | ) | const

protected

Helper method to generate mipmap levels by calling of glGenerateMipmapEXT. If it is not supported, then call the virtual allocateMipmap() method

## generateTextureObject() [1/2]

osg::ref_ptr< TextureObject > osg::Texture::generateTextureObject | ( | const Texture * | texture,
|  | unsigned int | contextID,
|  | GLenum | target )

static

References Texture().

Referenced by osg::Texture2D::SubloadCallback::generateTextureObject().

## generateTextureObject() [2/2]

osg::ref_ptr< TextureObject > osg::Texture::generateTextureObject | ( | const Texture * | texture,
|  | unsigned int | contextID,
|  | GLenum | target,
|  | GLint | numMipmapLevels,
|  | GLenum | internalFormat,
|  | GLsizei | width,
|  | GLsizei | height,
|  | GLsizei | depth,
|  | GLint | border )

static

References Texture().

## getBorderColor()

const Vec4d & osg::Texture::getBorderColor | ( |  | ) | const

inline

Gets the border color.

References _borderColor.

## getBorderWidth()

GLint osg::Texture::getBorderWidth | ( |  | ) | const

inline

References _borderWidth.

## getClientStorageHint()

bool osg::Texture::getClientStorageHint | ( |  | ) | const

inline

Gets whether to use client storage for the texture.

References _clientStorageHint.

## getCompressedSize()

void osg::Texture::getCompressedSize | ( | GLenum | internalFormat,
|  | GLint | width,
|  | GLint | height,
|  | GLint | depth,
|  | GLint & | blockSize,
|  | GLint & | size )

static

Determine the size of a compressed image, given the internalFormat, the width, the height, and the depth of the image. The block size and the size are output parameters.

## getFilter()

FilterMode osg::Texture::getFilter | ( | FilterParameter | which | ) | const

Gets the texture filter mode.

## getImage() [1/2]

virtual const Image * osg::Texture::getImage | ( | unsigned int | face | ) | const

pure virtual

Gets the const texture image for specified face.

Implemented in osg::Texture1D, osg::Texture2D, osg::Texture2DArray, osg::Texture2DMultisample, osg::Texture3D, osg::TextureBuffer, osg::TextureCubeMap, and osg::TextureRectangle.

## getImage() [2/2]

virtual Image * osg::Texture::getImage | ( | unsigned int | face | ) |

pure virtual

Gets the texture image for the specified face.

Implemented in osg::Texture1D, osg::Texture2D, osg::Texture2DArray, osg::Texture2DMultisample, osg::Texture3D, osg::TextureBuffer, osg::TextureCubeMap, and osg::TextureRectangle.

## getInternalFormat()

GLint osg::Texture::getInternalFormat | ( |  | ) | const

inline

Gets the internal texture format.

References _internalFormat, and computeInternalFormat().

## getInternalFormatMode()

InternalFormatMode osg::Texture::getInternalFormatMode | ( |  | ) | const

inline

Gets the internal texture format mode.

References _internalFormatMode.

## getInternalFormatType()

InternalFormatType osg::Texture::getInternalFormatType | ( |  | ) | const

inline

Get the internal texture format type.

References _internalFormatType.

## getLODBias()

float osg::Texture::getLODBias | ( |  | ) | const

inline

Sets the level of detail bias value.

References _lodbias.

## getMaxAnisotropy()

float osg::Texture::getMaxAnisotropy | ( |  | ) | const

inline

Gets the maximum anisotropy value.

References _maxAnisotropy.

## getMaxLOD()

float osg::Texture::getMaxLOD | ( |  | ) | const

inline

Gets the maximum level of detail value.

References _maxlod.

## getMinLOD()

float osg::Texture::getMinLOD | ( |  | ) | const

inline

Gets the minimum level of detail value.

References _minlod.

## getNumImages()

virtual unsigned int osg::Texture::getNumImages | ( |  | ) | const

pure virtual

Gets the number of images that can be assigned to this Texture.

Implemented in osg::Texture1D, osg::Texture2D, osg::Texture2DArray, osg::Texture2DMultisample, osg::Texture3D, osg::TextureBuffer, osg::TextureCubeMap, and osg::TextureRectangle.

## getReadPBuffer() [1/2]

GraphicsContext * osg::Texture::getReadPBuffer | ( |  | ) |

inline

Get the PBuffer graphics context to read from when using PBuffers for RenderToTexture.

References _readPBuffer.

## getReadPBuffer() [2/2]

const GraphicsContext * osg::Texture::getReadPBuffer | ( |  | ) | const

inline

Get the const PBuffer graphics context to read from when using PBuffers for RenderToTexture.

References _readPBuffer.

## getResizeNonPowerOfTwoHint()

bool osg::Texture::getResizeNonPowerOfTwoHint | ( |  | ) | const

inline

Gets whether texture will force non power to two images to be resized.

References _resizeNonPowerOfTwoHint.

## getShadowAmbient()

float osg::Texture::getShadowAmbient | ( |  | ) | const

inline

References _shadow_ambient.

## getShadowCompareFunc()

ShadowCompareFunc osg::Texture::getShadowCompareFunc | ( |  | ) | const

inline

References _shadow_compare_func.

## getShadowComparison()

bool osg::Texture::getShadowComparison | ( |  | ) | const

inline

References _use_shadow_comparison.

## getShadowTextureMode()

ShadowTextureMode osg::Texture::getShadowTextureMode | ( |  | ) | const

inline

References _shadow_texture_mode.

## getSourceFormat()

GLenum osg::Texture::getSourceFormat | ( |  | ) | const

inline

Gets the external source image format.

References _sourceFormat.

## getSourceType()

GLenum osg::Texture::getSourceType | ( |  | ) | const

inline

Gets the external source data type.

References _sourceType.

## getSwizzle()

const Vec4i & osg::Texture::getSwizzle | ( |  | ) | const

inline

Gets the source of texture swizzling for all channels

References _swizzle.

## getTextureDepth()

virtual int osg::Texture::getTextureDepth | ( |  | ) | const

inline virtual

Reimplemented in osg::Texture1D, osg::Texture2D, osg::Texture2DArray, osg::Texture2DMultisample, osg::Texture3D, osg::TextureBuffer, osg::TextureCubeMap, and osg::TextureRectangle.

## getTextureHeight()

virtual int osg::Texture::getTextureHeight | ( |  | ) | const

inline virtual

Reimplemented in osg::Texture1D, osg::Texture2D, osg::Texture2DArray, osg::Texture2DMultisample, osg::Texture3D, osg::TextureBuffer, osg::TextureCubeMap, and osg::TextureRectangle.

## getTextureObject()

TextureObject * osg::Texture::getTextureObject | ( | unsigned int | contextID | ) | const

inline

Returns a pointer to the TextureObject for the current context.

References _textureObjectBuffer.

## getTextureParameterDirty()

unsigned int & osg::Texture::getTextureParameterDirty | ( | unsigned int | contextID | ) | const

inline

Gets the dirty flag for the current contextID.

References _texParametersDirtyList.

## getTextureTarget()

virtual GLenum osg::Texture::getTextureTarget | ( |  | ) | const

pure virtual

Implemented in osg::Texture1D, osg::Texture2D, osg::Texture2DArray, osg::Texture2DMultisample, osg::Texture3D, osg::TextureBuffer, osg::TextureCubeMap, and osg::TextureRectangle.

References osg::StateAttribute::getModeUsage(), getTextureTarget(), and osg::StateAttribute::ModeUsage::usesTextureMode().

Referenced by getTextureTarget().

## getTextureWidth()

virtual int osg::Texture::getTextureWidth | ( |  | ) | const

inline virtual

Reimplemented in osg::Texture1D, osg::Texture2D, osg::Texture2DArray, osg::Texture2DMultisample, osg::Texture3D, osg::TextureBuffer, osg::TextureCubeMap, and osg::TextureRectangle.

## getType()

virtual Type osg::Texture::getType | ( |  | ) | const

inline virtual

Return the Type identifier of the attribute's class type.

Implements osg::StateAttribute.

References osg::StateAttribute::TEXTURE.

## getUnRefImageDataAfterApply()

bool osg::Texture::getUnRefImageDataAfterApply | ( |  | ) | const

inline

Gets whether or not apply() unreferences image data.

References _unrefImageDataAfterApply.

## getUseHardwareMipMapGeneration()

bool osg::Texture::getUseHardwareMipMapGeneration | ( |  | ) | const

inline

Gets the hardware mipmap generation hint.

References _useHardwareMipMapGeneration.

## getWrap()

WrapMode osg::Texture::getWrap | ( | WrapParameter | which | ) | const

Gets the texture wrap mode.

## isCompressedInternalFormat() [1/2]

bool osg::Texture::isCompressedInternalFormat | ( |  | ) | const

Return true if the internal format is one of the compressed formats.

## isCompressedInternalFormat() [2/2]

bool osg::Texture::isCompressedInternalFormat | ( | GLint | internalFormat | ) |

static

Determine whether the given internalFormat is a compressed image format.

## isDirty()

virtual bool osg::Texture::isDirty | ( | unsigned int |  | ) | const

inline virtual

return true if the texture image data has been modified and the associated GL texture object needs to be updated.

Reimplemented in osg::Texture1D, osg::Texture2D, osg::Texture2DArray, osg::Texture3D, osg::TextureBuffer, osg::TextureCubeMap, and osg::TextureRectangle.

## isHardwareMipmapGenerationEnabled()

bool osg::Texture::isHardwareMipmapGenerationEnabled | ( | const State & | state | ) | const

protected

Returns true if _useHardwareMipMapGeneration is true and either glGenerateMipmapEXT() or GL_GENERATE_MIPMAP_SGIS are supported.

## isSafeToUnrefImageData()

bool osg::Texture::isSafeToUnrefImageData | ( | const State & | state | ) | const

inline protected

Returns true if the associated Image should be released and it's safe to do so.

References _unrefImageDataAfterApply, areAllTextureObjectsLoaded(), and osg::State::getMaxTexturePoolSize().

## isSameKindAs()

virtual bool osg::Texture::isSameKindAs | ( | const osg::Object * | obj | ) | const

inline virtual

Return true if this and obj are of the same kind of object.

Reimplemented from osg::StateAttribute.

References NULL, and Texture().

## isTextureAttribute()

virtual bool osg::Texture::isTextureAttribute | ( |  | ) | const

inline virtual

Return true if StateAttribute is a type which controls texturing and needs to be issued w.r.t to specific texture unit.

Reimplemented from osg::StateAttribute.

## libraryName()

virtual const char * osg::Texture::libraryName | ( |  | ) | const

inline virtual

Return the name of the attribute's library.

Reimplemented from osg::StateAttribute.

## mipmapAfterTexImage()

void osg::Texture::mipmapAfterTexImage | ( | State & | state,
|  | GenerateMipmapMode | beforeResult ) const

protected

## mipmapBeforeTexImage()

GenerateMipmapMode osg::Texture::mipmapBeforeTexImage | ( | const State & | state,
|  | bool | hardwareMipmapOn ) const

protected

Helper methods to be called before and after calling gl[Compressed][Copy]Tex[Sub]Image2D to handle generating mipmaps.

## releaseGLObjects()

virtual void osg::Texture::releaseGLObjects | ( | State * | state = 0 | ) | const

virtual

If State is non-zero, this function releases OpenGL objects for the specified graphics context. Otherwise, releases OpenGL objects for all graphics contexts.

Reimplemented from osg::StateAttribute.

## resizeGLObjectBuffers()

virtual void osg::Texture::resizeGLObjectBuffers | ( | unsigned int | maxSize | ) |

virtual

Resize any per context GLObject buffers to specified size.

Reimplemented from osg::StateAttribute.

Reimplemented in osgText::GlyphTexture.

## selectSizedInternalFormat()

GLenum osg::Texture::selectSizedInternalFormat | ( | const osg::Image * | image = 0 | ) | const

## setBorderColor()

void osg::Texture::setBorderColor | ( | const Vec4d & | color | ) |

inline

Sets the border color. Only used when wrap mode is CLAMP_TO_BORDER. The border color will be casted to the appropriate type to match the internal pixel format of the texture.

References _borderColor, and dirtyTextureParameters().

## setBorderWidth()

void osg::Texture::setBorderWidth | ( | GLint | width | ) |

inline

Sets the border width.

References _borderWidth, and dirtyTextureParameters().

## setClientStorageHint()

void osg::Texture::setClientStorageHint | ( | bool | flag | ) |

inline

Sets whether to use client storage for the texture, if supported by the graphics system. Note: If enabled, and the graphics system supports it, the osg::Image(s) associated with this texture cannot be deleted, so the UnRefImageDataAfterApply flag would be ignored.

References _clientStorageHint.

## setFilter()

void osg::Texture::setFilter | ( | FilterParameter | which,
|  | FilterMode | filter )

Sets the texture filter mode.

Referenced by osg::TextureRectangle::TextureRectangle().

## setImage() [1/2]

template<class T>

void osg::Texture::setImage | ( | unsigned int | face,
|  | const ref_ptr< T > & | image )

inline

References osg::ref_ptr< T >::get(), and setImage().

Referenced by setImage().

## setImage() [2/2]

virtual void osg::Texture::setImage | ( | unsigned int | face,
|  | Image * | image )

pure virtual

Sets the texture image for the specified face.

Implemented in osg::Texture1D, osg::Texture2D, osg::Texture2DArray, osg::Texture2DMultisample, osg::Texture3D, osg::TextureBuffer, osg::TextureCubeMap, and osg::TextureRectangle.

## setInternalFormat()

void osg::Texture::setInternalFormat | ( | GLint | internalFormat | ) |

inline

Sets the internal texture format. Implicitly sets the internalFormatMode to USE_USER_DEFINED_FORMAT. The corresponding internal format type will be computed.

References _internalFormat, _internalFormatMode, computeInternalFormatType(), and USE_USER_DEFINED_FORMAT.

## setInternalFormatMode()

void osg::Texture::setInternalFormatMode | ( | InternalFormatMode | mode | ) |

inline

Sets the internal texture format mode. Note: If the texture format is USE_IMAGE_DATA_FORMAT, USE_ARB_COMPRESSION, or USE_S3TC_COMPRESSION, the internal format mode is set automatically and will overwrite the previous _internalFormat.

References _internalFormatMode.

## setLODBias()

void osg::Texture::setLODBias | ( | float | lodbias | ) |

Gets the level of detail bias value.

## setMaxAnisotropy()

void osg::Texture::setMaxAnisotropy | ( | float | anis | ) |

Sets the maximum anisotropy value, default value is 1.0 for no anisotropic filtering. If hardware does not support anisotropic filtering, use normal filtering (equivalent to a max anisotropy value of 1.0. Valid range is 1.0f upwards. The maximum value depends on the graphics system.

## setMaxLOD()

void osg::Texture::setMaxLOD | ( | float | maxlod | ) |

Sets the maximum level of detail value.

## setMinLOD()

void osg::Texture::setMinLOD | ( | float | minlod | ) |

Sets the minimum level of detail value.

## setReadPBuffer() [1/2]

template<class T>

void osg::Texture::setReadPBuffer | ( | const ref_ptr< T > & | context | ) |

inline

References osg::ref_ptr< T >::get(), and setReadPBuffer().

Referenced by setReadPBuffer().

## setReadPBuffer() [2/2]

void osg::Texture::setReadPBuffer | ( | GraphicsContext * | context | ) |

inline

Set the PBuffer graphics context to read from when using PBuffers for RenderToTexture.

References _readPBuffer.

## setResizeNonPowerOfTwoHint()

void osg::Texture::setResizeNonPowerOfTwoHint | ( | bool | flag | ) |

inline

Sets whether to force the texture to resize images that have dimensions that are not a power of two. If enabled, NPOT images will be resized, whether or not NPOT textures are supported by the hardware. If disabled, NPOT images will not be resized if supported by hardware.

References _resizeNonPowerOfTwoHint.

## setShadowAmbient()

void osg::Texture::setShadowAmbient | ( | float | shadow_ambient | ) |

inline

Sets the TEXTURE_COMPARE_FAIL_VALUE_ARB texture parameter. See http://oss.sgi.com/projects/ogl-sample/registry/ARB/shadow_ambient.txt.

References _shadow_ambient.

## setShadowCompareFunc()

void osg::Texture::setShadowCompareFunc | ( | ShadowCompareFunc | func | ) |

inline

Sets shadow texture comparison function.

References _shadow_compare_func.

## setShadowComparison()

void osg::Texture::setShadowComparison | ( | bool | flag | ) |

inline

Sets GL_TEXTURE_COMPARE_MODE_ARB to GL_COMPARE_R_TO_TEXTURE_ARB See http://oss.sgi.com/projects/ogl-sample/registry/ARB/shadow.txt.

References _use_shadow_comparison.

## setShadowTextureMode()

void osg::Texture::setShadowTextureMode | ( | ShadowTextureMode | mode | ) |

inline

Sets shadow texture mode after comparison.

References _shadow_texture_mode.

## setSourceFormat()

void osg::Texture::setSourceFormat | ( | GLenum | sourceFormat | ) |

inline

Sets the external source image format, used as a fallback when no osg::Image is attached to provide the source image format.

References _sourceFormat.

## setSourceType()

void osg::Texture::setSourceType | ( | GLenum | sourceType | ) |

inline

Sets the external source data type, used as a fallback when no osg::Image is attached to provide the source image format.

References _sourceType.

## setSwizzle()

void osg::Texture::setSwizzle | ( | const Vec4i & | swizzle | ) |

inline

Configure the source of texture swizzling for all channels

References _swizzle, and dirtyTextureParameters().

## setTextureObject()

void osg::Texture::setTextureObject | ( | unsigned int | contextID,
|  | TextureObject * | to )

inline

References _textureObjectBuffer.

## setUnRefImageDataAfterApply()

void osg::Texture::setUnRefImageDataAfterApply | ( | bool | flag | ) |

inline

Sets whether or not the apply() function will unreference the image data. If enabled, and the image data is only referenced by this Texture, apply() will delete the image data.

References _unrefImageDataAfterApply.

## setUseHardwareMipMapGeneration()

void osg::Texture::setUseHardwareMipMapGeneration | ( | bool | useHardwareMipMapGeneration | ) |

inline

Sets the hardware mipmap generation hint. If enabled, it will only be used if supported in the graphics system.

References _useHardwareMipMapGeneration.

Referenced by osg::Texture2D::Texture2D().

## setWrap()

void osg::Texture::setWrap | ( | WrapParameter | which,
|  | WrapMode | wrap )

Sets the texture wrap mode.

Referenced by osg::TextureRectangle::TextureRectangle().

## Member Data Documentation

## _borderColor

Vec4d osg::Texture::_borderColor

protected

Referenced by getBorderColor(), and setBorderColor().

## _borderWidth

GLint osg::Texture::_borderWidth

protected

Referenced by getBorderWidth(), and setBorderWidth().

## _clientStorageHint

bool osg::Texture::_clientStorageHint

protected

Referenced by getClientStorageHint(), and setClientStorageHint().

## _internalFormat

GLint osg::Texture::_internalFormat

mutable protected

Referenced by getInternalFormat(), and setInternalFormat().

## _internalFormatMode

InternalFormatMode osg::Texture::_internalFormatMode

protected

Referenced by getInternalFormatMode(), setInternalFormat(), and setInternalFormatMode().

## _internalFormatType

InternalFormatType osg::Texture::_internalFormatType

mutable protected

Referenced by getInternalFormatType().

## _lodbias

float osg::Texture::_lodbias

protected

Referenced by getLODBias().

## _mag_filter

FilterMode osg::Texture::_mag_filter

protected

## _maxAnisotropy

float osg::Texture::_maxAnisotropy

protected

Referenced by getMaxAnisotropy().

## _maxlod

float osg::Texture::_maxlod

protected

Referenced by getMaxLOD().

## _min_filter

FilterMode osg::Texture::_min_filter

protected

## _minlod

float osg::Texture::_minlod

protected

Referenced by getMinLOD().

## _readPBuffer

ref_ptr<GraphicsContext> osg::Texture::_readPBuffer

mutable protected

Referenced by getReadPBuffer(), getReadPBuffer(), and setReadPBuffer().

## _resizeNonPowerOfTwoHint

bool osg::Texture::_resizeNonPowerOfTwoHint

protected

Referenced by getResizeNonPowerOfTwoHint(), and setResizeNonPowerOfTwoHint().

## _shadow_ambient

float osg::Texture::_shadow_ambient

protected

Referenced by getShadowAmbient(), and setShadowAmbient().

## _shadow_compare_func

ShadowCompareFunc osg::Texture::_shadow_compare_func

protected

Referenced by getShadowCompareFunc(), and setShadowCompareFunc().

## _shadow_texture_mode

ShadowTextureMode osg::Texture::_shadow_texture_mode

protected

Referenced by getShadowTextureMode(), and setShadowTextureMode().

## _sourceFormat

GLenum osg::Texture::_sourceFormat

mutable protected

Referenced by getSourceFormat(), and setSourceFormat().

## _sourceType

GLenum osg::Texture::_sourceType

mutable protected

Referenced by getSourceType(), and setSourceType().

## _swizzle

Vec4i osg::Texture::_swizzle

protected

Referenced by getSwizzle(), and setSwizzle().

## _texMipmapGenerationDirtyList

TexParameterDirtyList osg::Texture::_texMipmapGenerationDirtyList

mutable protected

## _texParametersDirtyList

TexParameterDirtyList osg::Texture::_texParametersDirtyList

mutable protected

Referenced by getTextureParameterDirty().

## _textureObjectBuffer

TextureObjectBuffer osg::Texture::_textureObjectBuffer

mutable protected

Referenced by getTextureObject(), and setTextureObject().

## _unrefImageDataAfterApply

bool osg::Texture::_unrefImageDataAfterApply

protected

Referenced by getUnRefImageDataAfterApply(), isSafeToUnrefImageData(), and setUnRefImageDataAfterApply().

## _use_shadow_comparison

bool osg::Texture::_use_shadow_comparison

protected

Referenced by getShadowComparison(), and setShadowComparison().

## _useHardwareMipMapGeneration

bool osg::Texture::_useHardwareMipMapGeneration

protected

Referenced by getUseHardwareMipMapGeneration(), and setUseHardwareMipMapGeneration().

## _wrap_r

WrapMode osg::Texture::_wrap_r

protected

## _wrap_s

WrapMode osg::Texture::_wrap_s

protected

## _wrap_t

WrapMode osg::Texture::_wrap_t

protected

The documentation for this class was generated from the following file:

- Texture